## Grbl v1.1 激光模式

**_免责声明：激光是极其危险的设备。它们会立即引起火灾并永久损害您的视力。在使用之前，请阅读并理解您的激光器的所有相关文档。Grbl 项目不对固件可能导致的任何损坏或问题负责，如其 GPL 许可证所定义。_**

----

本文档概述了 Grbl 如何改变其新激光模式的运行条件，以提供改进的性能并尝试执行一些基本的用户安全预防措施。

## 激光模式概述

默认 Grbl 操作与激光模式之间的主要区别在于主轴/激光输出如何通过所涉及的运动进行控制。每次主轴状态‘M3 M4 M5’或主轴速度‘Sxxx’改变时，Grbl都会停止，让主轴改变，然后继续。这是铣床主轴的正常操作程序。改变速度需要时间。

但是，如果每次更换主轴时都像这样启动和停止激光，则会导致烧焦和切割/雕刻不均匀！Grbl 的新激光模式尽可能防止不必要的停止，并添加了新的动态激光功率模式，可根据与编程速率相关的当前速度自动调整功率。因此，即使在低加速度机器上，您也可以获得超级干净和清晰的结果！

启用或禁用 Grbl 的激光模式很容易。只需更改 **$32** Grbl 设置。
- **启用**：向 Grbl 发送 `$32=1` 命令。 
- **禁用：** 向 Grbl 发送 `$32=0` 命令。

**警告：** 如果您从激光模式切换回主轴进行铣削，您 **必须** 通过向 Grbl 发送 `$32=0` 命令来禁用激光模式。铣削操作要求主轴达到正确的转速以正确切割并确保**安全**，有助于防止刀具断裂和将金属碎片抛到各处。禁用激光模式后，Grbl 将在任何主轴速度或状态变化时短暂暂停，让主轴有机会在继续之前加速。


## 激光模式操作

启用激光模式后，Grbl 通过改变主轴 PWM D11 引脚的 **0-5V** 电压来控制激光功率。**0V** 应视为禁用，而 **5V** 为全功率。中间输出电压也被假定为与激光功率成线性关系，因此 **2.5V** 是大约 50% 的激光功率。（存在一个编译时选项来移动这个线性模型以从非零电压开始。）

默认情况下，主轴 PWM 频率为 **1kHz**，这是当前大多数 Grbl 兼容激光器系统的推荐 PWM 频率。如果需要不同的频率，可以通过编辑 `cpu_map.h` 文件进行更改。

使用“M3”主轴 CW 和“M4”主轴 CCW 命令启用激光。这些使两种不同的激光模式成为可能，这两种模式各有优势。
	
- **`M3` 恒定激光功率模式：**

    - 恒定激光功率模式只是保持编程的激光功率，无论机器是移动、加速还是停止。这提供了对激光状态的更好控制。使用良好的 G 代码程序，这可以在更困难的材料中实现更一致的切割。
    
    - 为了使用“M3”恒定功率模式进行干净的切割并防止烧焦，最好在要切割的线周围添加引入和引出运动，以便为机器提供一些空间来加速和减速。

    - 注意：“M3”可用于保持激光开启以进行聚焦。

- **`M4` 动态激光功率模式：**
    - 动态激光功率模式将根据相对于编程速率的当前速度自动调整激光功率。即使机器可能停止或主动加速，它基本上也能确保沿切割的激光能量量是一致的。这对于通过 CAM 程序通过大量 G 代码生成方法在简单材料上进行干净、精确的雕刻和切割非常有用。它通常会运行得更快，并且可能是您需要使用的全部。
    
    - Grbl 基于激光功率与速度和材料呈线性关系的假设来计算激光功率。通常，情况并非如此。激光可以在不同的功率水平下进行不同的切割，并且某些材料在特定的速度和/功率下可能无法很好地切割。简而言之，这意味着动态功耗模式可能不适用于所有情况。在将其与新材料或机器一起使用之前，请务必先进行测试。
		
    - 不运动时，“M4”动态模式会关闭激光。它仅在机器移动时打开。这通常会使激光操作更安全，因为与“M3”不同，它永远不会在您的桌子上烧一个洞，如果您停下来忘记及时关闭“M3”。

下面描述的是启用激光模式时 Grbl 的操作变化。请仔细阅读并充分理解它们，因为没有什么比车库_**火灾**更糟糕的了。

- 当使用新的“S”主轴速度（激光功率）编程时，Grbl 将通过 **连续** 运动命令连续移动。主轴 PWM 引脚将通过每次运动即时更新而不会停止。
	- 示例：以下一组 g 代码命令在启用激光模式时不会在每个命令之间暂停，但在禁用时会暂停。
	
		```
		G1 X10 S100 F50
		G1 X0 S90
		G2 X0 I5 S80
		``` 
	- Grbl 将在某些情况下强制执行激光模式运动停止。主要是为了确保更改与 g 代码程序保持同步。

		- 任何`M3`、`M4`、`M5`主轴状态_change_。 
		- 仅“M3”且未编程运动：“S”主轴速度_变化_。
		- 仅“M3”且未编程运动：“G1 G2 G3”激光供电状态_更改_为“G0 G80”激光禁用状态。
		- 注意：`M4` 不会因为主轴状态_变化_而停止。

- 只有当 Grbl 处于“G1”、“G2”或“G3”运动模式时，激光才会打开。 

	- 换句话说，“G0”快速运动模式或“G38.x”探测循环永远不会打开并始终禁用激光器，但仍会更新运行模态状态。当更改为“G1 G2 G3”模态状态时，Grbl 将根据当前运行状态立即启用激光器。
	
	- 请记住，“G0”是开机和复位时的默认运动模式。如果您想手动打开激光，则需要将其更改为“G1”、“G2”或“G3”。这是严格的安全措施。
	
	- 示例：`G0 M3 S1000` 不会打开激光器，而是将激光器模态状态设置为“M3”启用和“S1000”的功率。随后的“G1”命令将立即设置为“M3”和“S1000”。

	- 要在点动运动期间为激光器供电，首先启用有效的运动模式和主轴状态。以下点动运动将继承并保持先前​​的激光状态。不过请谨慎使用。这种能力主要是允许以_非常低的_功率打开激光，以使用激光点点动并明显定位作业的开始位置。


- “S0”主轴速度为零将关闭激光器。当使用有效的激光运动编程时，Grbl 将立即禁用激光，而不会在该运动和未来运动的持续时间内停止，直到设置大于零。

	- “M3”恒定激光模式，这是关闭激光功率的好方法，同时在“G1”激光运动和“G0”快速运动之间连续移动而无需停止。在“G0”运动之前编写一个简短的“G1 S0”运动，并在返回切割之后立即命令“G1 Sxxx”运动。


-----
### CAM 开发人员实施说明

TODO：添加一些关于如何为 Grbl 编写激光 G 代码的建议。 

- 使用“M3”恒定激光功率模式时，尽可能避免在作业期间出现强制同步情况。基本上每次主轴速度变化都必须伴随有效的运动。任何运动都很好，因为 Grbl 会根据模态状态自动启用和禁用激光。避免在此模式下和作业中间使用没有轴字的“G0”和“G1”命令。

- 通过在没有“M3 M4 M5”主轴状态命令的情况下打开和关闭激光器，确保整个运动平稳。有两种方法可以做到这一点：

    - _编程零主轴速度`S0`_：`S0`是有效的G代码，关闭主轴/激光而不改变主轴状态。在激光模式下，Grbl 将通过连续运动平稳移动并关闭主轴。相反，您可以以大于零的主轴速度“S”打开激光器。请记住，“M3”恒定功率模式需要将任何主轴速度“S”变化编程为允许连续运动，而“M4”动态功率模式则不需要。

    - _在动力运动之间编程无动力运动_：如果您正在光栅作业的不需要激光供电的部分之间移动，请在它们之间快速编程“G0”。`G0` 强制自动禁用激光。最后编程的主轴速度不会改变，因此如果之后执行了有效的动力运动，例如“G1”，则在执行该运动时，它将立即以最后编程的主轴速度重新为激光器供电。
