## 入门

首先，使用您选择的串行终端连接到 Grbl。

将波特率设置为 **115200** 为 8-N-1（8 位，无奇偶校验，1 个停止位。）

一旦连接
 你应该得到 Grbl 提示，它看起来像这样：

``
Grbl 1.1d ['$' 寻求帮助]
``

输入 $ 并按回车键让 Grbl 打印帮助信息。您不应该看到 $ 的任何本地回声并输入。Grbl 应该回应：

``
[HLP:$$ $# $G $I $N $x=val $Nx=line $J=line $SLP $C $X $H ~ ! ? ctrl-x]
``

'$'-commands 是 Grbl 系统命令，用于调整设置、查看或更改 Grbl 的状态和运行模式，以及启动归位循环。最后四个 **non**-'$' 命令是实时控制命令，可以随时发送，不管 Grbl 在做什么。这些要么立即改变 Grbl 的运行行为，要么立即打印重要实时数据的报告，如当前位置（又名 DRO）。

***

## Grbl 设置

#### $$ - 查看 Grbl 设置
要查看设置，请在连接到 Grbl 后键入 `$$` 并按 Enter。Grbl 应该以当前系统设置的列表作为响应，如下例所示。所有这些设置都是持久的并保存在 EEPROM 中，因此如果您断电，这些设置将在您下次启动 Arduino 时重新加载。

`$x=val` 的 `x` 表示特定设置，而 `val` 是设置值。在 Grbl 的先前版本中，每个设置旁边都有一个描述，位于“()”括号中，但不幸的是 Grbl v1.1+ 不再包含它们。这样做是为了释放宝贵的闪存以添加 v1.1 中可用的新功能。但是，大多数优秀的 GUI 都会通过为您附加说明来提供帮助，这样您就知道自己在看什么。

``
$0=10
$1=25
$2=0
$3=0
$4=0
$5=0
$6=0
$10=1
$11=0.010
$12=0.002
$13=0
$20=0
$21=0
$22=1
$23=0
$24 = 25.000
$25 = 500.000
$26 = 250
$27=1.000
$30=1000。
$31 = 0。
$32=0
$100=250.000
$101=250.000
$102=250.000
$110 = 500.000
$111 = 500.000
$112 = 500.000
$120=10.000
$121 = 10.000
$122=10.000
$130 = 200.000
$131 = 200.000
$132 = 200.000
``

#### $x=val - 保存 Grbl 设置

`$x=val` 命令保存或更改 Grbl 设置，当通过串行终端程序连接到 Grbl 时，可以通过发送此命令手动完成，但大多数 Grbl GUI 会为您执行此操作，作为用户友好的功能。

要手动将微秒步进脉冲选项更改为 10us，您可以输入以下内容，然后输入：
``
$0=10
``
如果一切顺利，Grbl 将回复“ok”，并且此设置存储在 EEPROM 中，并将永远保留或直到您更改它们。您可以通过输入“$$”再次查看系统设置来检查 Grbl 是否已正确接收和存储您的设置。


***

## Grbl 的 `$x=val` 设置及其含义

**注意：从 Grbl v0.9 到 Grbl v1.1，只有 `$10` 状态报告发生了变化，并添加了新的 `$30`/`$31` 主轴转速最大值/最小值和 `$32` 激光模式设置。其他一切都一样。**

#### $0 – 步进脉冲，微秒

步进驱动器的额定最小步进脉冲长度。检查数据表或只是尝试一些数字。您需要步进驱动器能够可靠识别的最短脉冲。如果脉冲太长，则在以非常高的进给和脉冲速率运行系统时可能会遇到麻烦，因为阶跃脉冲可能会开始相互重叠。我们建议大约 10 微秒，这是默认值。

#### $1 - 步骤空闲延迟，毫秒

每次您的步进器完成一个运动并停止时，Grbl 将延迟禁用步进器此值。**或**，通过将此值设置为最大 255 毫秒，您可以始终保持轴启用（通电以保持位置）。再次重申，您可以通过设置“$1=255”来保持所有轴始终处于启用状态。

步进器空闲锁定时间是 Grbl 在禁用之前将保持步进器锁定的时间长度。根据系统，您可以将其设置为零并禁用它。在其他情况下，您可能需要 25-50 毫秒来确保您的轴在禁用之前完全停止。这是为了帮助解决不喜欢长时间不做任何事情的机器电机。另外，请记住，一些步进驱动器不记得他们停在哪个微步上，因此当您重新启用时，您可能会因此目睹一些“丢失”的步数。在这种情况下，只需通过 `$1=255` 启用步进器。

#### $2 – 步进端口反转，掩码

此设置反转步进脉冲信号。默认情况下，阶跃信号从正常低电平开始，并在步进脉冲事件发生时变为高电平。在由“$0”设置的步进脉冲时间后，引脚复位为低电平，直到下一个步进脉冲事件。当反转时，步进脉冲行为从正常高电平切换到脉冲期间的低电平，然后返回高电平。大多数用户不需要使用此设置，但这对于某些具有特殊要求的 CNC 步进驱动程序很有用。例如，可以通过反转步进引脚来创建方向引脚和步进脉冲之间的人为延迟。

此反转掩码设置是将要反转的轴存储为位标志的值。你真的不需要完全理解它是如何工作的。您只需为要反转的轴输入设置值。例如，如果您想反转 X 轴和 Z 轴，您需要发送 `$2=5` 到 Grbl，并且设置现在应该显示为 `$2=5 (step port invert mask:00000101)`。

| 设置值 | 掩码 |反转 X | 反转 Y | 反转 Z |
|:-------------:|:----:|:-------:|:--------:|:---- ----:|
| 0 | 00000000 |N | 否 | 否 |
| 1 | 00000001 |是 | 否 | 否 |
| 2 | 00000010 |N | 是 | 否 |
| 3 | 00000011 |是 | 是 | 否 |
| 4 | 00000100 |N | 否 | 是 |
| 5 | 00000101 |是 | 否 | 是 |
| 6 | 00000110 |N | 是 | 是 |
| 7 | 00000111 |是 | 是 | 是 |

#### $3 – 方向端口反转，掩码

此设置反转每个轴的方向信号。默认情况下，Grbl 假设轴在方向引脚信号为低电平时向正方向移动，而在引脚为高电平时轴向负方向移动。通常，轴不会在某些机器上以这种方式移动。此设置将反转那些以相反方式移动的轴的方向引脚信号。

此反转掩码设置的工作方式与步进端口反转掩码完全相同，并将要反转的轴存储为位标志。要配置此设置，您只需发送要反转的轴的值。使用上表。例如，如果只想反转 Y 轴方向，您需要将 `$3=2` 发送到 Grbl，并且设置现在应为 `$3=2 (dir port invert mask:00000010)`

#### $4 - 启用步进反转，布尔值

默认情况下，步进器启用引脚为高电平禁用，低电平启用。如果您的设置需要相反的设置，只需通过键入“$4=1”来反转步进器启用引脚。使用“$4=0”禁用。（可能需要重启电源才能加载更改。）

#### $5 - 限制引脚反转，布尔值

默认情况下，限制引脚通过 Arduino 的内部上拉电阻保持正常高电平。当限制引脚为低电平时，Grbl 将其解释为已触发。对于相反的行为，只需通过键入“$5=1”来反转限制引脚。使用“$5=0”禁用。您可能需要重新启动才能加载更改。

注意：如果您反转限制引脚，则需要一个外部下拉电阻连接到所有限制引脚，以防止电流使引脚过载并炸毁它们。

#### $6 - 探针引脚反转，布尔值

默认情况下，探针通过 Arduino 的内部上拉电阻保持常高。当探针为低电平时，Grbl 将其解释为已触发。对于相反的行为，只需通过键入“$6=1”来反转探针。使用“$6=0”禁用。您可能需要重新启动才能加载更改。

注意：如果您反转探针，您将需要一个连接到探针的外部下拉电阻器，以防止电流过载并炸毁它。


#### $10 - 状态报告，掩码

这个设置决定了当'?'时它向用户报告什么Grbl实时数据。发送状态报告。该数据包括当前运行状态、实时位置、实时进给速率、引脚状态、当前覆盖值、缓冲区状态和当前执行的 g 代码行号（如果通过编译时选项启用）。

默认情况下，Grbl v1.1+ 中的新报告实现将包含标准状态报告中的几乎所有内容。许多数据是隐藏的，只有在它发生变化时才会出现。这大大提高了旧报告样式的效率，并允许您获得更快的更新并仍然获得更多关于您的机器的数据。界面文档概述了它的工作原理，其中大部分仅适用于 GUI 开发人员或好奇的人。

为了保持简单和一致，Grbl v1.1 只有两个报告选项。这些主要是为了用户和开发人员帮助设置。

- 可以指定位置类型以显示机器位置 (`MPos:`) 或工作位置 (`WPos:`)，但不再同时显示两者。通过串口终端直接与Grbl交互时，在某些场景下启用工作位置很有用，但默认情况下应使用_机器位置报告。_
- 可以启用 Grbl 的规划器和串行 RX 缓冲区的使用数据。这显示了相应缓冲区中可用的块数或字节数。这通常用于帮助确定 Grbl 在测试流接口时的性能。_默认情况下应禁用此功能。_

使用下表启用和禁用报告选项。只需添加列出的您想要启用的值，然后通过向 Grbl 发送您的设置值来保存它。例如，带有机器位置和无缓冲区数据报告设置的默认报告是“$10=1”。如果需要工作位置和缓冲区数据，则设置为“$10=2”。

| 报告类型 | 值 | 说明 |
|:-------------:|:----:|:----:|
| 职位类型 | 1 | 启用`MPos：`。禁用`WPos：`。|
| 缓冲数据 | 2 | 已启用的`Buf:` 字段与规划器和串行 RX 可用缓冲区一起出现。

#### $11 - 结点偏差，毫米

加速管理器使用结点偏差来确定它可以通过 G 代码程序路径的线段结点移动的速度。例如，如果 G 代码路径有一个 10 度的急转弯并且机器正在全速移动，则此设置有助于确定机器需要减速多少才能安全地通过拐角而不会丢失步数。

我们如何计算它有点复杂，但是，一般来说，较高的值会在拐角处提供更快的运动，同时增加丢失步数和定位的风险。较低的值使加速管理器更加小心，并会导致谨慎和缓慢的转弯。因此，如果您遇到机器试图过快拐角的问题，请*减小*此值以使其在进入拐角时变慢。如果您希望您的机器在路口移动得更快，请*增加*此值以加快速度。对于好奇的人，请点击此 [链接](http://t.co/KQ5BvueY) 以了解 Grbl 的转弯算法，该算法使用非常简单、高效和稳健的方法计算速度和连接角。

#### $12 – 弧度公差，毫米

Grbl 通过将 G2/G3 圆、圆弧和螺旋细分为极细的线来渲染它们，这样圆弧跟踪精度就不会低于此值。您可能永远不需要调整此设置，因为“0.002mm”远低于大多数所有 CNC 机器的精度。但如果您发现您的圆太粗糙或圆弧跟踪执行缓慢，请调整此设置。较低的值可提供较高的精度，但可能会因使用过多细线使 Grbl 过载而导致性能问题。或者，较高的值跟踪到较低的精度，但可以加快电弧性能，因为 Grbl 需要处理的线较少。

奇怪的是，弧度公差被定义为线段的最大垂直距离，线段的端点位于弧线上，也就是弦。使用一些基本几何图形，我们求解线段的长度以跟踪满足此设置的弧。以这种方式对弧进行建模非常棒，因为弧线段会自动调整和随长度缩放，以确保最佳的弧跟踪性能，同时不会失去准确性。

#### $13 - 报告英寸，布尔值

Grbl 具有实时定位报告功能，可为用户提供有关机器当时确切位置以及坐标偏移和探测参数的反馈。默认情况下，它设置为以毫米为单位进行报告，但是通过发送“$13=1”命令，您将此布尔标志发送为 true，这些报告功能现在将以英寸为单位进行报告。`$13=0` 设置回 mm。

#### $20 - 软限位，布尔值

软限位是一项安全功能，可帮助防止您的机器行驶太远或超出行驶限制、碰撞或损坏昂贵的东西。它的工作原理是了解每个轴的最大行程限制以及 Grbl 在机器坐标中的位置。每当向 Grbl 发送新的 G 代码运动时，它都会检查您是否意外超出了机器空间。如果这样做，Grbl 将在任何地方立即发出进给暂停，关闭主轴和冷却液，然后设置系统警报以指示问题。机器位置将在之后保留，因为它不是由于像硬限位那样立即强制停止。

注意：软限位需要启用归位和准确的轴最大行程设置，因为 Grbl 需要知道它在哪里。`$20=1` 启用，`$20=0` 禁用。

#### $21 - 硬限位，布尔值

硬限位的工作原理与软限位基本相同，但使用物理开关代替。基本上，您在每个轴的行程末端附近连接一些开关（机械的、磁性的或光学的），或者如果您的程序移动得太远而可能会出现问题，则可能会出现问题。当开关触发时，它将立即停止所有运动，关闭冷却液和主轴（如果已连接），并进入警报模式，这将迫使您检查机器并重置所有内容。

要对 Grbl 使用硬限位，限制引脚通过内部上拉电阻保持高电平，因此您要做的就是将引脚和地连接到常开开关中，并使用“$21=1”启用硬限位. （禁用`$21=0`。）我们强烈建议采取电干扰预防措施。如果您想对一个轴的行程两端进行限制，只需将两个开关与引脚和接地并联连接，如果其中任何一个跳闸，就会触发硬限位。

请记住，硬限位事件被认为是关键事件，在这种事件中，步进器会立即停止并且可能会丢失步数。Grbl 没有任何关于位置的反馈，所以它不能保证它知道它在哪里。因此，如果触发硬限位，Grbl 将进入无限循环报警模式，让您有机会检查您的机器并强制您重置 Grbl。请记住，这纯粹是一项安全功能。

#### $22 - 归位周期，布尔值

啊，归位。对于那些刚开始使用 CNC 的人，每次在会话之间启动 Grbl 时，都会使用归位循环来准确、准确地定位机器上已知且一致的位置。换句话说，您每次都确切地知道您在任何给定时间的位置。假设您开始加工某物或即将开始工作的下一步并且停电，您重新启动 Grbl 并且 Grbl 不知道它在哪里。剩下的任务就是弄清楚自己在哪里。如果你有归位，你总是有机器零参考点来定位，所以你所要做的就是运行归位循环并从你离开的地方继续。

要为 Grbl 设置归位周期，您需要将限位开关置于不会受到撞击或移动的固定位置，否则您的参考点会被弄乱。通常它们设置在每个轴的+x、+y、+z 的最远点。将限位开关连接到限位销和地线，就像使用硬限位一样，并启用归位。如果您好奇，您可以将限位开关用于硬限位和归位。他们玩得很开心。

默认情况下，Grbl 的归位循环首先向正方向移动 Z 轴以清除工作空间，然后沿正向同时移动 X 和 Y 轴。要设置您的归位周期的行为方式，页面下方有更多 Grbl 设置，描述了它们的作用（以及编译时选项。）

另外，还要注意一件事，当启用归位时。Grbl 将锁定所有 G 代码命令，直到您执行归位循环。意味着没有轴运动，除非锁定被禁用（$X），但稍后会更多。大多数（如果不是全部）CNC 控制器都会做类似的事情，因为它主要是一种安全功能，可以防止用户犯定位错误，这很容易做到，并且在错误毁坏零件时会感到难过。如果你觉得这很烦人或发现任何奇怪的错误，请告诉我们，我们会努力解决这个问题，让每个人都开心。:)

注意：查看 config.h 以获得更多高级用户的归位选项。您可以在启动时禁用归位锁定，配置在归位周期中哪些轴首先移动以及按什么顺序移动，等等。


#### $23 - 归位方向反转，掩码

默认情况下，Grbl 假设您的归位限位开关处于正方向，首先将 z 轴正向移动，然后将 xy 轴正向移动，然后尝试通过围绕开关缓慢地前后移动来精确定位机器零位。如果您的机器在负方向有一个限位开关，归位方向掩码可以反转轴的方向。它的工作原理类似于步进端口反转和方向端口反转掩码，您所要做的就是发送表中的值以指示要反转的轴并在相反方向搜索。

#### $24 - 归位进给，毫米/分钟

归位循环首先以较高的寻道率搜索限位开关，找到后，以较慢的进给率移动，以归位到机器零的精确位置。归位进给速度是较慢的进给速度。将此设置为提供可重复且精确的机器零位定位的任何速率值。

#### $25 - 寻航，毫米/分钟

归位搜索率是归位周期搜索率，或它首先尝试找到限位开关的速率。在足够短的时间内调整到限位开关的任何速率，而不会在限位开关进入太快时撞到限位开关。

#### $26 - 归位去抖动，毫秒

每当开关触发时，它们中的一些可能会产生电气/机械噪声，在稳定之前实际上将信号高低“反弹”几毫秒。要解决这个问题，您需要通过带有某种硬件的硬件去抖动信号调节器或通过具有短延迟的软件来让信号完成弹跳。Grbl 执行短暂延迟，仅在定位机器零时归位。将此延迟值设置为您的交换机获得可重复归位所需的任何值。大多数情况下，5-25 毫秒就可以了。

#### $27 - 归位回拉，毫米

为了更好地使用硬限位功能，其中归位可以共享相同的限位开关，归位循环将在完成后通过此拉断行程移开所有限位开关。换句话说，它有助于防止在归位周期后意外触发硬限位。

#### $30 - 最大主轴速度，RPM

这将设置最大 5V PWM 引脚输出的主轴速度。Grbl 接受更高的编程主轴 RPM，但 PWM 输出不会超过最大 5V。默认情况下，Grbl 将最大-最小 RPM 与 5V-0.02V PWM 引脚输出线性关联，增量为 255。当 PWM 引脚读数为 0V 时，表示主轴已禁用。请注意，config.h 中有其他配置选项可用于调整其运行方式。

#### $31 - 最低主轴转速，RPM

这将设置最小 0.02V PWM 引脚输出（0V 禁用）的主轴速度。Grbl 接受较低的 RPM 值，但 PWM 输出不会低于 0.02V，除非 RPM 为零。如果为零，主轴被禁用，PWM 输出为 0V。

#### $32 - 激光模式，布尔值

启用后，Grbl 将在使用“S”主轴速度（激光功率）编程时通过连续的“G1”、“G2”或“G3”运动命令连续移动。主轴 PWM 引脚将通过每次运动即时更新而不会停止。在使用此模式之前，请阅读 Grbl 激光文档和您的激光设备文档。激光是非常危险的。它们会立即永久性地损害您的视力并引起火灾。Grbl 不对固件可能导致的任何问题承担任何责任，如其 GPL 许可证所定义。

禁用时，Grbl 将像往常一样运行，在每个“S”主轴速度命令时停止运动。这是铣床的默认操作，允许暂停让主轴改变速度。

#### $100, $101 和 $102 – [X,Y,Z] 步/毫米

Grbl 需要知道在现实中每一步将使用该工具多远。要计算机器轴的步数/毫米，您需要知道：

* 步进电机每转的毫米数。这取决于您的皮带传动齿轮或丝杠螺距。
* 步进电机每转的完整步数（通常为 200）
* 控制器每步的微步数（通常为 1、2、4、8 或 16）。_提示：使用高微步值（例如 16）可以降低步进电机扭矩，因此请使用最低的值，以提供所需的轴分辨率和舒适的运行特性。_

步数/mm 可以这样计算：```steps_per_mm = (steps_per_revolution*microsteps)/mm_per_rev```

为每个轴计算这个值并将这些设置写入 Grbl。

#### $110, $111 和 $112 – [X,Y,Z] 最大速率，毫米/分钟

这将设置每个轴可以移动的最大速率。每当 Grbl 计划移动时，它都会检查移动是否导致这些单独的轴中的任何一个超过其最大速率。如果是这样，它将减慢运动速度以确保没有任何轴超过其最大速率限制。这意味着每个轴都有自己独立的速度，这对于限制通常较慢的 Z 轴非常有用。

确定这些值的最简单方法是通过缓慢增加最大速率设置并移动它来一次测试每个轴。例如，要测试 X 轴，请发送 Grbl 类似“G0 X50”的具有足够行程距离的内容，以便轴加速到其最大速度。当您的步进器停止时，您就会知道您已达到最大速率阈值。它会产生一点噪音，但不应该伤害您的电机。输入一个比该值低 10-20% 的设置，这样您就可以考虑工件/工具的磨损、摩擦和质量。然后，对其他轴重复此操作。

注意：此最大速率设置还设置了 G0 寻道速率。

#### $120, $121, $122 – [X,Y,Z] 加速度，mm/sec^2

这以毫米/秒/秒为单位设置轴加速度参数。简单地说，较低的值使 Grbl 变得更慢，而较高的值会产生更紧密的移动并更快地达到所需的进给率。与最大速率设置非常相似，每个轴都有自己的加速度值并且彼此独立。这意味着多轴运动只会以最低贡献轴的速度加速。

同样，与最大速率设置一样，确定此设置值的最简单方法是使用缓慢增加的值单独测试每个轴，直到电机停转。然后使用比该绝对最大值低 10-20% 的值来完成您的加速度设置。这应该考虑磨损、摩擦和质量惯性。我们强烈建议您在提交之前使用新设置对一些 G 代码程序进行干测试。有时，当所有轴一起移动时，机器上的负载会有所不同。


#### $130, $131, $132 – [X,Y,Z] 最大行程，毫米

这以毫米为单位设置每个轴从一端到另一端的最大行程。这仅在您启用了软限位（和归位）时才有用，因为这仅被 Grbl 的软限位功能用于检查您是否使用运动命令超出了机器限制。
